/*
** executable win32 module for nanoasm.
** (C) 2007, Alexander G. Karpov a.k.a. mrhx.
** version 1.0.
** January 7, 2007.
**
** http://mrhx.narod.ru/  [ru]
** http://mrhx.t35.com/   [en]
*/
#include <windows.h>

#pragma comment(linker,"/NODEFAULTLIB")
#pragma comment(linker,"/ENTRY:main")
#pragma comment(linker,"/FILEALIGN:512")
#pragma comment(linker,"/MERGE:.data=.text")
#pragma comment(linker,"/MERGE:.rdata=.text")
#pragma comment(linker,"/SECTION:.text,ERWX")
#pragma comment(linker,"/IGNORE:4078")

void * _stdcall GetAddressOfProc(const char *LibName, const char *ProcName)
{
	HMODULE hMod;
	void *Proc;

	hMod = LoadLibrary(LibName);
	if (!hMod)
	{
		MessageBox(NULL, "[nanoasm] could not load library", LibName, MB_TOPMOST | MB_ICONWARNING | MB_OK);
		return NULL;
	}

	Proc = GetProcAddress(hMod, ProcName);
	if (!Proc) MessageBox(NULL, "[nanoasm] could not get address of procedure", ProcName, MB_TOPMOST | MB_ICONWARNING | MB_OK);
	return Proc;
}

int _cdecl Proc(void *GetProcAdr);

void main()
{
//	unsigned char *ptr = (unsigned char *) GetModuleHandle(NULL);
//	PIMAGE_DOS_HEADER doshdr = (PIMAGE_DOS_HEADER) ptr;
//	PIMAGE_NT_HEADERS nthdr = (PIMAGE_NT_HEADERS)(ptr + doshdr->e_lfanew);
//	long size = nthdr->OptionalHeader.SizeOfCode + nthdr->OptionalHeader.SizeOfHeaders;
	ExitProcess(Proc(GetAddressOfProc));
}

int _cdecl Proc(void *GetProcAdr)
{
	return 0;
}
